unit misc;

interface

uses
	defs, miscdef;

procedure writecfg;
procedure readcfg;

implementation

procedure writecfg;
var
	fptr : file;
begin
	assign(fptr, cfgname);
	rewrite(fptr, 1);
	blockwrite(fptr, cfg, sizeof(cfg));
	close(fptr);
end;

procedure readcfg;
var
	fptr : file;
begin
	assign(fptr, cfgname);
	{$i-} reset(fptr, 1); {$I+}
	if ioresult <> 0 then
	begin
		fillchar(cfg, sizeof(cfg), 0);
		SetupCfg(cfg);
		writecfg;
		exit;
	end;

	{$i-} blockread(fptr, cfg, sizeof(cfg)); {$I+}
	if ioresult <> 0 then
	begin
		writeln('File '+cfgname+' has an invalid length.  This may indicate you have an old');
		writeln('configuration file.  Please delete this file and reinstall.');
		halt;
	end;

	close(fptr);
end;



end.
