unit strznnp;

interface

uses crt, dos;


type znnp = record
	zone,net,node,point : word;
end;

type o_fi = ( DFidoNet, DInternet );
const s_fi : array [DFidoNet..DInternet] of string[20]
	= ('FidoNet', 'Internet');

type sysznnp = record
	t		: o_fi;
	case integer of
		0: ( z		: znnp;
			 dummy 	: word; );
		1: ( s 	    : array [0..9] of char; );
end;


function strtoznnp(thing : string; var z : znnp) : boolean;
function znnptostr(z : znnp) : string;
function upstr(s : string) : string;
function addrcmp(a, b : znnp) : boolean;


implementation

function upstr(s : string) : string;
var lp : integer;
begin
	for lp := 1 to length(s) do
        	s[lp] := upcase(s[lp]);
        upstr := s;
end;

function vals(s : string) : word;
var w : word; n : integer;
begin
	val(s, w, n);
	vals := w;
end;

function strs(w : word) : string;
var s : string;
begin
	str(w, s);
        strs := s;
end;

function strtoznnp(thing : string; var z : znnp) : boolean;
var
	thingy  : string[120];
        n       : integer;
begin
	strtoznnp := false;

        if (pos('@', thing) > 0) then
        	delete(thing, pos('@', thing), 100);

	if (pos('.', thing) = 0) then
		thing := thing + '.0';

	thingy := thing;
	n := pos(':', thingy);
	if (n = 0) then
		exit;
	delete(thingy, n, 100);
	if (upstr(thingy) = 'ALL') or (thingy = '*') then
		z.zone := 65535
	else
		z.zone := vals(thingy);


	thingy := copy(thing, pos(':', thing)+1, 100);
	n := pos('/', thingy);
	if (n = 0) then
		exit;
	delete(thingy, n, 100);
	if (upstr(thingy) = 'ALL') or (thingy = '*') then
		z.net := 65535
	else
		z.net := vals(thingy);

	thingy := copy(thing, pos('/', thing)+1, 100);
	n := pos('.', thingy);
	if (n = 0) then
		exit;
	delete(thingy, n, 100);
	if (upstr(thingy) = 'ALL') or (thingy = '*') then
		z.node := 65535
	else
		z.node := vals(thingy);

	thingy := copy(thing, pos('.', thing)+1, 100);
	if (upstr(thingy) = 'ALL') or (thingy = '*') then
		z.point := 65535
	else
		z.point := vals(thingy);
	
	strtoznnp := true;
end;

function znnptostr(z : znnp) : string;
var s : string;
begin
	if (z.zone = 65535) then s := '*:' else s := strs(z.zone)+':';
	if (z.net = 65535) then s := s + '*/' else s := s + strs(z.net)+'/';
	if (z.node = 65535) then s := s + '*' else s := s + strs(z.node);
	if (z.point > 0) then
		if (z.point = 65535) then s := s + '.*' else s := s + '.' + strs(z.point);
	znnptostr := s;
end;

function addrcmp(a, b : znnp) : boolean;
begin
	addrcmp := (a.zone = b.zone) and (a.net = b.net) and (a.node = b.node) and (a.point = b.point);
end;


end.