unit slnter;

interface

uses filedef, xcrt;

procedure high;
procedure low;

function  bar_yesno : char;
function  bar_noyes	: char;

procedure init_barmenu;
procedure add_barmenu(t, d : string);
function  disp_barmenu(var pos : byte) : char;
function  disp_barmenu_1 : char;

procedure init_listmenu;
procedure add_listmenu(d : string);
procedure desc_listmenu(d : string);
function  disp_listmenu(var at : byte) : byte;

procedure heading(s : string);


type _barmenu = record
   title : string[20];
   desc : string[80];
   keypos : byte;
end;

type _listmenu = record
   desc : string[60];
   hot  : char;
end;


var
	barmenu	: array [1..20] of _barmenu;
	listmenu: array [1..26] of _listmenu;
	x		: word;
	ansi	: boolean;
	startx	: word;
	added	: word;

	nlist	: word;
	nhot	: word;
	highon  : boolean;

implementation

procedure high;
begin
	xtextcolor(cf.colorchart[INVERSE]);
	xtextbackground(cf.colorchart[BACKGROUND]);
	highon := true;
end;

procedure low;
begin
	xtextcolor(cf.colorchart[NORMAL]);
	xtextbackground(black);
	highon := false;
end;

function bar_yesno : char;
var ch : char;
begin
	init_barmenu;
	add_barmenu('Yes', '');
	add_barmenu('No', '');
	bar_yesno := disp_barmenu_1;
end;

function bar_noyes : char;
var ch : char;
begin
	init_barmenu;
	add_barmenu('No', '');
	add_barmenu('Yes', '');
	bar_noyes := disp_barmenu_1;
end;

procedure init_barmenu;
begin
	added := 0;
	fillchar(barmenu, sizeof(_barmenu)*20, 0);
end;

procedure add_barmenu(t, d : string);
var
	n, lp : integer;
begin
	n := 1;
	while (barmenu[n].title <> '') do
		inc(n);
	barmenu[n].title := t;
	barmenu[n].desc := d;

	for lp := 1 to length(t) do
	begin
		if (t[lp] < #97) then
		begin
			barmenu[n].keypos := lp;
			lp := length(t);
		end;
	end;

	inc(added);

	if (barmenu[n].keypos = 0) then
		barmenu[n].keypos := 1;
end;



function disp_barmenu_na : char;
var
	lp, pos : byte;
	ch : char;
label maine;
begin
	lp := 1;
	while (barmenu[lp].title <> '') do
	begin
		xwrite(copy(barmenu[lp].title, 1, barmenu[lp].keypos-1));
		xwrite('(');
		xwrite(barmenu[lp].title[barmenu[lp].keypos]);
		xwrite(')');
		xwrite(copy(barmenu[lp].title, barmenu[lp].keypos+1, 100));

		if barmenu[lp+1].title <> '' then
			xwrite(', ');
		inc(lp);
	end;
	xwrite(' ? ');

maine:
	ch := xreadkey;

	if (ch = #27) then
	begin
		lp := 1;
		pos := 0;
		while (barmenu[lp].title <> '') do
		begin
			if (barmenu[lp+1].title = '') then
				pos := lp;
			inc(lp);
		end;

		disp_barmenu_na := upcase(barmenu[pos].title[barmenu[pos].keypos]);
		exit;
	end;

	ch := upcase(ch);
	lp := 1;
	while (barmenu[lp].title <> '') and (lp <> 0) do
	begin
		if (upcase(barmenu[lp].title[barmenu[lp].keypos]) = ch) then
		begin
			pos := lp;
			lp := 0;
		end
		else
			inc(lp);
	end;

	if (lp = 0) then
	begin
		disp_barmenu_na := ch;
		exit;
	end;

	goto maine;
end;



procedure dispm(pos : byte; lp : byte);
begin
	if (pos = lp) then
	begin
		xtextbackground(cf.colorchart[BACKGROUND]);
		xtextcolor(cf.colorchart[INVERSE]);
		xwrite(' '+barmenu[lp].title+' ');
		xtextbackground(black);
		x := xwherex;
		if (barmenu[lp].desc <> '') then
		begin
			xwriteln('');
			xtextcolor(cf.colorchart[SPECIAL]);
			xclreol;
			xwrite(barmenu[lp].desc);
			xgotoxy(x,xwherey-1);
		end;
	end
	else
	begin
		xwrite(' ');
		if (barmenu[lp].keypos = 1) then
		begin
			xtextcolor(cf.colorchart[SPECIAL]);
			xwrite(barmenu[lp].title[1]);
			xtextcolor(cf.colorchart[PROMPTCOLOR]);
			xwrite(copy(barmenu[lp].title, 2, 100));
		end
		else
		begin
			xtextcolor(cf.colorchart[PROMPTCOLOR]);
			xwrite(copy(barmenu[lp].title, 1, barmenu[lp].keypos-1));
			xtextcolor(cf.colorchart[SPECIAL]);
			xwrite(barmenu[lp].title[barmenu[lp].keypos]);
			xtextcolor(cf.colorchart[PROMPTCOLOR]);
			xwrite(copy(barmenu[lp].title, barmenu[lp].keypos+1, 100));
		end;
		xwrite(' ');
	end;
end;

function disp_barmenu(var pos : byte) : char;
var
	lp : byte;
	ch : char;
	d : word;
label maine;

begin
	if (ansi = false) then
	begin
		disp_barmenu := disp_barmenu_na;
		exit;
	end;

	startx := xwherex;

	lp := 1;
	while (barmenu[lp].title <> '') do
	begin
		dispm(pos, lp);
		inc(lp);
	end;

	xgotoxy(x, xwherey);

maine:
	ch := xreadkey;
	if (ch = #0) then
	begin
		ch := xreadkey;
		if (ch = #77) then
		begin
			inc(pos);
			xgotoxy(xwherex-length(barmenu[pos-1].title)-2, xwherey);
			dispm(pos, pos-1);
			if (barmenu[pos].title = '') then
			begin
				xgotoxy(startx,xwherey);
				pos := 1;
			end;
			dispm(pos, pos);
			goto maine;
		end;

		if (ch = #75) then
		begin
			dec(pos);
			xgotoxy(xwherex-length(barmenu[pos+1].title)-2, xwherey);
			dispm(pos+2, pos+1);

			if (pos = 0) then
			begin
				lp := 1;
				d := startx;
				while (barmenu[lp+1].title <> '') do
				begin
					inc(d, length(barmenu[lp].title)+2);
					inc(lp);
				end;
				pos := lp;
				xgotoxy(d, xwherey);
			end
			else
				xgotoxy(xwherex-length(barmenu[pos+1].title)-length(barmenu[pos].title)-4, xwherey);

			dispm(pos, pos);

			goto maine;
		end;

		goto maine;
	end;

	ch := upcase(ch);
	lp := 1;
	while (barmenu[lp].title <> '') and (lp <> 0) do
	begin
		if (upcase(barmenu[lp].title[barmenu[lp].keypos]) = ch) then
		begin
			pos := lp;
			lp := 0;
		end
		else
			inc(lp);
	end;

	if (lp = 0) then
	begin
		lp := 1;
		xgotoxy(startx,xwherey);
		while (barmenu[lp].title <> '') do
		begin
			dispm(pos, lp);
			inc(lp);
		end;

		disp_barmenu := ch;
		exit;
	end;

	if (ch = #13) then
	begin
		disp_barmenu := upcase(barmenu[pos].title[barmenu[pos].keypos]);
		exit;
	end;

	if (ch = #27) then
	begin
		lp := 1;
		pos := 0;
		xgotoxy(startx,xwherey);
		while (barmenu[lp].title <> '') do
		begin
			if (barmenu[lp+1].title = '') then
				pos := lp;
			dispm(pos, lp);
			inc(lp);
		end;

		disp_barmenu := upcase(barmenu[pos].title[barmenu[pos].keypos]);
		exit;
	end;

	goto maine;
end;

function disp_barmenu_1 : char;
var p : byte;
begin
	p := 1;
	disp_barmenu_1 := disp_barmenu(p);
end;


procedure init_listmenu;
begin
	nlist := 1;
	nhot := 65;
end;

procedure add_listmenu(d : string);
begin
	listmenu[nlist].desc := d;
	listmenu[nlist].hot := chr(nhot);
	inc(nlist);
	inc(nhot);
end;

procedure desc_listmenu(d : string);
begin
	listmenu[nlist].desc := d;
	listmenu[nlist].hot := #0;
	inc(nlist);
end;

function disp_listmenu(var at : byte) : byte;
var
	lp : integer;
	ch : char;
	max : byte;
	highon : boolean;
	starty : byte;

  procedure putline(lp : byte);
  begin
	if (listmenu[lp].hot = #0) then
	begin
		xgotoxy(13, lp+starty);
		xtextcolor(WHITE);
		xwriteln('  '+listmenu[lp].desc);
		xtextcolor(cf.colorchart[NORMAL]);
	end
	else
	begin
		xgotoxy(21, lp+starty);
		xwrite('  '+listmenu[lp].hot+'. '+listmenu[lp].desc);
{                if (highon = true) then}
                	for lp := length(listmenu[lp].desc) to max+1 do
							xwrite(' ');
	end;
end;

begin
	disp_listmenu := 27;
	if nlist = 1 then exit;
	while (listmenu[at].hot = #0) and (at < nlist) do
		inc(at);
	if (at = nlist) then exit;

	starty := xwherey;
	max := 0;
	for lp := 1 to nlist-1 do
		if (length(listmenu[lp].desc) > max) then
			max := length(listmenu[lp].desc);

	low;
	for lp := 1 to nlist-1 do
		putline(lp);
	high;
	putline(at);

	while true do
	begin
		ch := upcase(xreadkey);
		case ch of
		  #0:
		  begin
			ch := xreadkey;
			case ch of
			  #80:
			  begin
				low;
				putline(at);
				repeat
					inc(at);
					if at > nlist-1 then
						at := 1;
				until listmenu[at].hot <> #0;
				high;
				putline(at);
			  end;
			  #72:
			  begin
				low;
				putline(at);
				repeat
					dec(at);
					if at = 0 then
						at := nlist-1;
				until listmenu[at].hot <> #0;
				high;
				putline(at);
			  end;
			end;
		  end;

		  #27:
		  begin
			disp_listmenu := 27;
			low;
			exit;
		  end;

		  #13:
		  begin
			disp_listmenu := at;
			low;
			exit;
		  end;

		  'A'..'Z':
		  begin
			for lp := 1 to nlist do
			begin
				if (listmenu[lp].hot = ch) then
				begin
					at := lp;
					disp_listmenu := lp;
					low;
					exit;
				end;
			end;
		  end;
		end;
	end;
end;



procedure heading(s : string);
var ss : string; lp : integer;
begin
	xclrscr;
	xtextcolor(cf.colorchart[HEADCOLOR]);
	ss := '';
	for lp := 1 to length(s) do
		ss := ss + s[lp] + ' ';

	xgotoxy((80-length(ss)) div 2, 1);
	xwriteln(ss);
	xtextcolor(cf.colorchart[NORMAL]);
end;


end.
