unit binkbar;

interface

uses
	xcrt, dos,
	mogutils,
	defs, output, utils,
	filedef;


function bar_routines(s : string) : boolean;

implementation

var
	baron		: boolean;
	viewing		: integer;
	binkloc		: integer;

	sx, sy		: integer;

procedure SaveScr;
begin
	sx := xwherex; sy := xwherey;
	if sy < 16 then sy := 16;
	xwindow(1, 1, scrbx, scrby);
end;

procedure ResetScr;
begin
	xwindow(1, 16, scrbx, scrby);
	xgotoxy(sx, sy);
end;

procedure BarScrOn;
var
	lp, pp, n	: integer;
begin
	xstrwrite(#27'[15r');

	for lp := 1 to 15 do
	begin
		xgotoxy(1, lp);
		xclreol;
	end;

	xgotoxy(1, 1);
	xtextbackground(red);
	xtextcolor(yellow);
	xclreol;
	xgotoxy(68, 1);
	xwrite('Binky''s Bar');

	xgotoxy(1, 15);
	xclreol;
	xgotoxy(57, 15);
	xwrite('MogTalk Teleconference');

	xtextbackground(black);

	xgotoxy(1, 3);

	slwriteln('\BR    ');
	slwriteln('\YE  ');
	slwriteln('  ');
	slwriteln('                                                                       ');
	slwriteln('                                                                       ');
	slwriteln('                                                                       ');
	slwriteln('    \BR \BR\IV\YE\BR\BR\IV\YE\NO\BR');
	slwriteln('   \BR\IV\YE\BR\BR\IV\YE\NO\BR');
	slwriteln('\YE  ');
	slwriteln('  ');
	slwriteln('  ');

end;

procedure BarScrOff;
var
  lp		: integer;
begin
	for lp := 1 to 16 do
	begin
		xgotoxy(1, lp);
		xclreol;
	end;

	xstrwrite(#27'[1r');
end;


function bar_routines(s : string) : boolean;
var
  w1		: string;
begin
	w1 := aword(s, 1, false);

	bar_routines := true;

	if w1 = '/bar' then
	begin
		enteruserline;

		if not baron then
		begin
			if scrty0 <> 0 then
			begin
				slwriteln('\WH * You can only have two MogTalk windows open at once.');
				exit;
			end;

			SaveScr;
			BarScrOn;
			ResetScr;

			slwriteln('\WH * Welcome to \LRBi\RDn\LRky\WH''s bar!  How can I help?  8-)');
			baron := true;
			exit;
		end;

		baron := false;
		SaveScr;
		BarScrOff;
		xgotoxy(sx, sy);

		slwriteln('\WH * Thanks for visiting \LRBi\RDn\LRky\WH''s bar!');
		exit;
	end;

	bar_routines := false;
end;



begin
	baron := false;
	viewing := 0;
	binkloc := 0;
end.
