unit miscdef;

interface

uses
	defs, menudef;

procedure SetupCfg(var cfg : cfgtype);

const cfgname = 'MOGTALK.CFG';

implementation

procedure SetupCfg(var cfg : cfgtype);
begin
  with cfg do
  begin
	PrivLvl				:= 1;

	WeenieLvl			:= 255;
	BeepLvl				:= 200;

	ViewOpCmds			:= 210;
	ChanOpLvl			:= 210;
	RenameLvl			:= 215;
	ConfOpLvl			:= 215;
	CantSilenceLvl		:= 215;
	CantKickLvl			:= 215;

	BootLvl				:= 215;
	SysLvl				:= 215;

	AllowTabLvl			:= 220;
	BanLvl				:= 220;
	MacroLvl			:= 240;
	IgnorePasswordLvl	:= 255;
	DispRealNameLvl		:= 255;
	SetConfOpLvl		:= 255;
	AdjTimeLvl			:= 255;
	AdjMPLvl			:= 255;
	NoTimeLvl			:= 255;
	OrderLvl			:= 255;
	FreezeLvl			:= 255;
	SetLvl				:= 255;
	WriteLvl			:= 255;
	CantBanLvl			:= 255;
	RenameOverrideLvl	:= 255;
	CantBootLvl			:= 255;
	SetAbbrLvl			:= 255;
	ScanAllLvl			:= 255;
	InvisibleLvl		:= 255;

	WritingIndent		:= 2;
	NoticeIndent		:= 3;


	PointsForSuccessfulWeenie	:= 1;
	PointsForFailedWeenie		:= -1;

	CostToWeenie				:= 100;
	CostToNosui					:= 10;

	maxnodes := 20;
	channeldir := '.\';
	realtimedir := '.\';
	gamedir := '.\';
	logmgrdir := '';

	defusrcol := '\CY';
	defmsgcol := '\GR';
	defwhiscol := '\YE';
  end;
end;


end.
