unit oth_def;

interface

const _ver = '0.90';

type
	statet = ( NotSetup, NotStarted, InProgress, Finished, Won, Drawn );
	piece = (PNone, PBlack, PWhite);

	boardtype = array [1..8,1..8] of piece;

	position = record
		x, y	: byte;
	end;

	gamet = record
		player_w, player_b	: string[25];
		turn				: piece;
		state				: statet;
		board				: boardtype;
		winner				: piece;
	end;


const
	PieceName : array [PNone..PWhite] of string[6] =
		( ' ', '\GR', '\WH' );

	states : array [NotSetup..Drawn] of string[20] =
		( 'Not Setup', 'Not Started', 'In Progress', 'Finished', 'Won', 'Drawn' );


var
	sx, sy 		: word;
	inited		: boolean;
	viewing		: word;

implementation


begin
	inited := false;
	viewing := 0;
end.
