unit scr;

interface

uses
	xcrt, output;


procedure PutHeading(head : string; double : boolean);
procedure PutTrailer(double : boolean);

function  GetHeading(head : string; double : boolean) : string;
function  GetTrailer(double : boolean) : string;

var
	linecol		: integer;

implementation

function GetHeading(head : string; double : boolean) : string;
var
  lp	: integer;
  li 	: string[5];
  s		: string;
begin
	if double then
		li := 'Ƶ'
	else
		li := 'ô';

	fillchar(s, linecol - length(head), li[1]);
	s[0] := chr(linecol-length(head)-1);

	s := '\BL' + s + li[3] + ' \LC' + head + ' \BL' + li[2] + li[1] + li[1] + li[1];

	GetHeading := s;
end;

procedure PutHeading(head : string; double : boolean);
begin
	slextwrite(GetHeading(head, double)+#13#10, false, false);
end;

function GetTrailer(double : boolean) : string;
var
  lp	: integer;
  li 	: string[5];
  s		: string;
begin
	if double then
		li := 'Ƶ'
	else
		li := 'ô';

	fillchar(s, linecol+7, li[1]);
	s[0] := chr(linecol+6);

	GetTrailer := '\BL'+s;
end;

procedure PutTrailer(double : boolean);
begin
	slextwrite(GetTrailer(double)+#13#10, false, false);
end;

begin
	linecol := 71;
end.